--##****************************************************
--##**	ZONE CONTROL FOR SUPREME COMMANDER    **
--##**			        BY SAYA                                          **
--##**			       V 1.0 BETA                                        **
--##
--##             extented by Cleopatre
--##****************************************************

-- map by Cleopatre
local player_equivalent={} --{ARMY_1="ARMY_5",ARMY_2="ARMY_6",ARMY_3="ARMY_7",ARMY_4="ARMY_8",ARMY_5="ARMY_1",ARMY_6="ARMY_2",ARMY_7="ARMY_3",ARMY_8="ARMY_4"}
local player_equivalent_i={}
local upgrade_unit='ual0105' --'URL0107'
local ACU_unit='uel0001'   --'uel0301'
local maxUnit=200  -- for perf raison
local mass_earn=15
local energy_earn=70
local cost_zone_Mass=1
local cost_zone_Energy = 10
local max_ai_step=20
local turn=0
local turn_of_alert=4
local attack_size_min=15
local formation_used='None' --'TravellingFormation'
--'AttackFormation',     'GrowthFormation',     'SixWideFormation',    'TravellingFormation',
local att_cat=categories.TECH1+categories.TECH2+categories.TECH3+categories.EXPERIMENTAL-categories.STRUCTURE+categories.SUBCOMMANDER

local cat_pd=categories.ALLUNITS-categories.TECH2*categories.DEFENSE
		+categories.ANTIAIR+categories.ANTINAVY+categories.SHIELD+categories.ANTIMISSILE
local first_time=true
--scenario utilities
local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')
local Utilities = import('/lua/utilities.lua')

--interface utilities
local UIUtil = import('/lua/ui/uiutil.lua')
local gameParent = import('/lua/ui/game/gamemain.lua').GetGameParent()

local executing = false
local mainBeatTime = 1
local spawnBeatTime = 7 -- 5 + nbr_player
local brainBeatTime = 5

--TRIGGER TABLES
local bunkerDeath = {}
local unitDeath = {}
local zone_add=0
local tigger_AI_change_behavior=30



--PLAYERS, CONTAINS USEFUL INFO FOR THE SCRIPT FOR EACH PLAYER
local playersDATA = {
	['player1'] = {
		name = 'player1', 
		index=1,
		kills = 0, 
		bunkerType = 'ueb2101',
		zonecontrol = 1, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		upgrader = false,
		kamikazeShop = false,
		startLocation = {1,5},
		defeated = false,
		ai={step=1,
			x_obj=3,
			y_obj=4,
			start=true,
			objectif_define=false,
			objectif_timer=0,
			objectif_x=0,
			objectif_y=0,
			att_platoon=false,
			def_platoon=false,
			danger=false,
			old_house_x=0,
			old_house_y=0,
			
			
			attack_plan1={x=2.1,y=5,min_trp=5,wait_ctr=true,x_obj=2,y_obj=5 },
			attack_plan2={x=3.1,y=5,min_trp=5,wait_ctr=true,x_obj=3,y_obj=5 ,skipifenemy=true},
			attack_plan3={x=3.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},
			attack_plan4={x=3.1,y=2.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},
			attack_plan5={x=4.1,y=2.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			attack_plan6={x=4.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			
			attack_plan7={x=1,y=3.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=4 ,skipifenemy=true},
			attack_plan8={x=1,y=2.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=3 ,skipifenemy=true},
			attack_plan9={x=1,y=1.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=2 ,skipifenemy=true},
			attack_plan10={x=2.1,y=2.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=3 ,skipifenemy=true},
			attack_plan11={x=2.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=4 ,skipifenemy=true},
			attack_plan12={x=2.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=5 ,skipifenemy=true},
			attack_plan13={x=2.1,y=5.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=6 ,skipifenemy=true},
			attack_plan14={x=3.1,y=5.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=6 ,skipifenemy=true},
			attack_plan15={x=3.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},

			
			},	
	},
	['player2'] = {
		name = 'player2', 
		index=2,
		kills = 0, 
		bunkerType = 'ueb2101',
		zonecontrol = 1, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		upgrader = false,		
		kamikazeShop = false,
		startLocation = {2,1},
		defeated = false,
			ai={step=1,
			x_obj=3,
			y_obj=3,
			start=true,
			objectif_define=false,
			objectif_timer=0,
			objectif_x=0,
			objectif_y=0,
			att_platoon=false,
			def_platoon=false,
			danger=false,
			old_house_x=0,
			old_house_y=0,
			attack_plan1={x=2,y=2.1,min_trp=5,wait_ctr=true,x_obj=2,y_obj=2 },
			attack_plan2={x=2,y=3.1,min_trp=5,wait_ctr=true,x_obj=2,y_obj=3 ,skipifenemy=true},
			attack_plan3={x=3.1,y=3.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},
			attack_plan4={x=4.1,y=3.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			attack_plan5={x=4.1,y=4.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			attack_plan6={x=3.1,y=4.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},
			
			attack_plan7={x=3.1,y=1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=1 ,skipifenemy=true},
			attack_plan8={x=4.1,y=1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=1 ,skipifenemy=true},
			attack_plan9={x=5.1,y=1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=1 ,skipifenemy=true},
			attack_plan10={x=3.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=2 ,skipifenemy=true},
			attack_plan11={x=2.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=2 ,skipifenemy=true},
			attack_plan12={x=1.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=2,y_obj=2 ,skipifenemy=true},
			attack_plan13={x=0.9,y=1.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=2 ,skipifenemy=true},
			attack_plan14={x=.9,y=2.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=3 ,skipifenemy=true},
			attack_plan15={x=3.1,y=3.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},		
			},	

	},
	['player3'] = {
		name = 'player3',
		index=3,
		kills = 0, 
		bunkerType = 'ueb2101',
		zonecontrol = 1, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		upgrader = false,
		kamikazeShop = false,
		startLocation = {6,2},
		defeated = false,
		ai={step=1,
			x_obj=4,
			y_obj=3,
			objectif_define=false,
			objectif_timer=0,
			objectif_x=0,
			objectif_y=0,
			att_platoon=false,
			def_platoon=false,
			start=true,
			danger=false,
			old_house_x=0,
			old_house_y=0,
			attack_plan1={x=4.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=2 },
			attack_plan2={x=3.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=2 ,skipifenemy=true},
			attack_plan3={x=3.9,y=3.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			attack_plan4={x=3.9,y=4.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			attack_plan5={x=2.9,y=4.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},
			attack_plan6={x=2.9,y=3.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},
			
			attack_plan7={x=6,y=3.1,min_trp=5,wait_ctr=true,x_obj=6,y_obj=3 ,skipifenemy=true},
			attack_plan8={x=6,y=4.1,min_trp=5,wait_ctr=true,x_obj=6,y_obj=4 ,skipifenemy=true},
			attack_plan9={x=6,y=5.1,min_trp=5,wait_ctr=true,x_obj=6,y_obj=5 ,skipifenemy=true},
			attack_plan10={x=4.9,y=3.1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=3 ,skipifenemy=true},
			attack_plan11={x=4.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=2 ,skipifenemy=true},
			attack_plan12={x=4.9,y=.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=1 ,skipifenemy=true},
			attack_plan13={x=3.9,y=.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=1 ,skipifenemy=true},
			attack_plan14={x=2.9,y=.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=1 ,skipifenemy=true},
			attack_plan15={x=3.9,y=3.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			},	
	},
	['player4'] = {
		name = 'player4', 
		index=4,
		kills = 0, 
		bunkerType = 'ueb2101',
		zonecontrol = 1, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		upgrader = false,
		kamikazeShop = false,
		startLocation = {5,6},
		defeated = false,
		ai={step=1,
			x_obj=4,
			y_obj=4,
			objectif_define=false,
			objectif_timer=0,
			objectif_x=0,
			objectif_y=0,
			att_platoon=false,
			def_platoon=false,
			start=true,
			danger=false,
			old_house_x=0,
			old_house_y=0,
			attack_plan1={x=4.9,y=4.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=5 },
			attack_plan2={x=4.9,y=3.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=4 ,skipifenemy=true},
			attack_plan3={x=3.9,y=3.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			attack_plan4={x=2.9,y=3.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},
			attack_plan5={x=2.9,y=2.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},
			attack_plan6={x=3.9,y=2.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			attack_plan7={x=3.9,y=3.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 },
			
			attack_plan8={x=3.9,y=6,min_trp=5,wait_ctr=true,x_obj=4,y_obj=6 ,skipifenemy=true},
			attack_plan9={x=2.9,y=6,min_trp=5,wait_ctr=true,x_obj=3,y_obj=6 ,skipifenemy=true},
			attack_plan10={x=1.9,y=6,min_trp=5,wait_ctr=true,x_obj=2,y_obj=6 ,skipifenemy=true},
			attack_plan11={x=3.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=5 ,skipifenemy=true},
			attack_plan12={x=4.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=5 ,skipifenemy=true},
			attack_plan13={x=5.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=5 ,skipifenemy=true},
			attack_plan14={x=6.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=6,y_obj=5 ,skipifenemy=true},
			attack_plan15={x=6.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=6,y_obj=4 ,skipifenemy=true},
			attack_plan16={x=3.9,y=3.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			},	
	},
	['player5'] = {
		name = 'player5', 
		index=5,
		kills = 0, 
		bunkerType = 'ueb2101',
		zonecontrol = 1, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		upgrader = false,
		kamikazeShop = false,
		startLocation = {1,5},
		defeated = false,
		ai={step=1,
			x_obj=2,
			y_obj=5,
			objectif_define=false,
			objectif_timer=0,
			objectif_x=0,
			objectif_y=0,
			att_platoon=false,
			def_platoon=false,
			start=true,
			danger=false,
			old_house_x=0,
			old_house_y=0,
			attack_plan1={x=1,y=3.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=4 },
			attack_plan2={x=1,y=3.6,min_trp=5,wait_ctr=false },
			attack_plan3={x=1,y=2.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=3 ,skipifenemy=true},
			attack_plan4={x=1,y=1.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=2 ,skipifenemy=true},
			attack_plan5={x=2.1,y=2.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=3 ,skipifenemy=true},
			attack_plan6={x=2.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=4 ,skipifenemy=true},
			attack_plan7={x=2.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=5 ,skipifenemy=true},
			attack_plan8={x=2.1,y=5.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=6 ,skipifenemy=true},
			attack_plan9={x=3.1,y=5.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=6 ,skipifenemy=true},
			
			
			attack_plan10={x=2.1,y=5,min_trp=5,wait_ctr=true,x_obj=2,y_obj=5 ,skipifenemy=true},
			attack_plan11={x=3.1,y=5,min_trp=5,wait_ctr=true,x_obj=3,y_obj=5 ,skipifenemy=true},
			attack_plan12={x=3.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},
			attack_plan13={x=3.1,y=2.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},
			attack_plan14={x=4.1,y=2.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			attack_plan15={x=4.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			attack_plan16={x=2.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=2,y_obj=5 ,skipifenemy=true},
			},		
	},
	['player6'] = {
		name = 'player6', 
		index=6,
		kills = 0, 
		bunkerType = 'ueb2101',
		zonecontrol = 1, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		upgrader = false,		
		kamikazeShop = false,
		startLocation = {2,1},
		defeated = false,
		ai={step=1,
			x_obj=2,
			y_obj=2,
			objectif_define=false,
			objectif_timer=0,
			objectif_x=0,
			objectif_y=0,
			att_platoon=false,
			def_platoon=false,
			start=true,
			danger=false,
			old_house_x=0,
			old_house_y=0,
			attack_plan1={x=3.1,y=1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=1 },
			attack_plan2={x=3.4,y=1,min_trp=5,wait_ctr=false },
			attack_plan3={x=4.1,y=1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=1 ,skipifenemy=true},
			attack_plan4={x=5.1,y=1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=1 ,skipifenemy=true},
			attack_plan5={x=3.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=2 ,skipifenemy=true},
			attack_plan6={x=2.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=2 ,skipifenemy=true},
			attack_plan7={x=1.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=2,y_obj=2 ,skipifenemy=true},
			attack_plan8={x=0.9,y=1.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=2 ,skipifenemy=true},
			attack_plan9={x=.9,y=2.9,min_trp=5,wait_ctr=true,x_obj=1,y_obj=3 ,skipifenemy=true},
			
			attack_plan10={x=2,y=2.1,min_trp=5,wait_ctr=true,x_obj=2,y_obj=2 ,skipifenemy=true},
			attack_plan11={x=2,y=3.1,min_trp=5,wait_ctr=true,x_obj=2,y_obj=3 ,skipifenemy=true},
			attack_plan12={x=3.1,y=3.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},
			attack_plan13={x=4.1,y=3.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			attack_plan14={x=4.1,y=4.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			attack_plan15={x=3.1,y=4.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},
			attack_plan16={x=1.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=2,y_obj=2 ,skipifenemy=true},
			
			},	
		},
	['player7'] = {
		name = 'player7',
		index=7,
		kills = 0, 
		bunkerType = 'ueb2101',
		zonecontrol = 1, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		upgrader = false,
		kamikazeShop = false,
		startLocation = {6,2},
		defeated = false,
		ai={step=1,
			x_obj=5,
			y_obj=2,
			objectif_define=false,
			objectif_timer=0,
			objectif_x=0,
			objectif_y=0,
			att_platoon=false,
			def_platoon=false,
			start=true,
			danger=false,
			old_house_x=0,
			old_house_y=0,
			attack_plan1={x=6,y=3.1,min_trp=5,wait_ctr=true,x_obj=6,y_obj=3 },
			attack_plan2={x=6,y=3.5,min_trp=5,wait_ctr=false },
			attack_plan3={x=6,y=4.1,min_trp=5,wait_ctr=true,x_obj=6,y_obj=4 ,skipifenemy=true},
			attack_plan4={x=6,y=5.1,min_trp=5,wait_ctr=true,x_obj=6,y_obj=5 ,skipifenemy=true},
			attack_plan5={x=4.9,y=3.1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=3 ,skipifenemy=true},
			attack_plan6={x=4.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=2 ,skipifenemy=true},
			attack_plan7={x=4.9,y=.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=1 ,skipifenemy=true},
			attack_plan8={x=3.9,y=.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=1 ,skipifenemy=true},
			attack_plan9={x=2.9,y=.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=1 ,skipifenemy=true},
			
			attack_plan10={x=4.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=2 ,skipifenemy=true},
			attack_plan11={x=3.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=2 ,skipifenemy=true},
			attack_plan12={x=3.9,y=3.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			attack_plan13={x=3.9,y=4.1,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			attack_plan14={x=2.9,y=4.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},
			attack_plan15={x=2.9,y=3.1,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},
			attack_plan16={x=4.9,y=2.1,min_trp=5,wait_ctr=true,x_obj=5,y_obj=2 ,skipifenemy=true},
			
			},	
	},
	['player8'] = {
		name = 'player8', 
		index=8,
		kills = 0, 
		bunkerType = 'ueb2101',
		zonecontrol = 1, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		upgrader = false,
		kamikazeShop = false,
		startLocation = {5,6},
		defeated = false,
		ai={step=1,
			x_obj=5,
			y_obj=5,
			objectif_define=false,
			objectif_timer=0,
			objectif_x=0,
			objectif_y=0,
			att_platoon=false,
			def_platoon=false,
			start=true,
			danger=false,
			old_house_x=0,
			old_house_y=0,
			attack_plan1={x=3.9,y=6,min_trp=5,wait_ctr=true,x_obj=4,y_obj=6 },
			attack_plan2={x=3.5,y=6,min_trp=5,wait_ctr=false },
			attack_plan3={x=2.9,y=6,min_trp=5,wait_ctr=true,x_obj=3,y_obj=6 ,skipifenemy=true},
			attack_plan4={x=1.9,y=6,min_trp=5,wait_ctr=true,x_obj=2,y_obj=6 ,skipifenemy=true},
			attack_plan5={x=3.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=5 ,skipifenemy=true},
			attack_plan6={x=4.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=5 ,skipifenemy=true},
			attack_plan7={x=5.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=5 ,skipifenemy=true},
			attack_plan8={x=6.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=6,y_obj=5 ,skipifenemy=true},
			attack_plan9={x=6.1,y=3.9,min_trp=5,wait_ctr=true,x_obj=6,y_obj=4 ,skipifenemy=true},
			
			attack_plan10={x=4.9,y=4.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=5 ,skipifenemy=true},
			attack_plan11={x=4.9,y=3.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=4 ,skipifenemy=true},
			attack_plan12={x=3.9,y=3.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=4 ,skipifenemy=true},
			attack_plan13={x=2.9,y=3.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=4 ,skipifenemy=true},
			attack_plan14={x=2.9,y=2.9,min_trp=5,wait_ctr=true,x_obj=3,y_obj=3 ,skipifenemy=true},
			attack_plan15={x=3.9,y=2.9,min_trp=5,wait_ctr=true,x_obj=4,y_obj=3 ,skipifenemy=true},
			attack_plan16={x=5.1,y=4.9,min_trp=5,wait_ctr=true,x_obj=5,y_obj=5 ,skipifenemy=true},
			
			},	
	},	
	
	['neutral'] = {
		name = 'neutral', 
		kills = 0, 
		index=0,
		bunkerType = 'urb2101', -- 'urb2301',
		zonecontrol = 0, 
		attack = 0, 
		defence = 0, 
		upgrades = 1, 
		level = 0,
		money = 0,
		infoUnit = false,
		attackUnit = false,
		defenceUnit = false,
		kamikazeShop = false,
		upgrader = false,
		defeated = false,
	},
}

local players = {}

local defeatcount = 0
local gameEnd = false
local beat = 0



local armyTable = {
	 ['ARMY_1'] = 'player1',
	 ['ARMY_2'] = 'player2',
	 ['ARMY_3'] = 'player3',
	 ['ARMY_4'] = 'player4',
	 ['ARMY_5'] = 'player5',
	 ['ARMY_6'] = 'player6',
	 ['ARMY_7'] = 'player7',
	 ['ARMY_8'] = 'player8',
	 ['ARMY_9'] = 'neutral',
}


local upgradeList = {
	['LEVEL 1'] = { level = 1, kills = 50, upgrade = 2, description = 'LEVEL 1: TANK 400 HP'},   
	['LEVEL 2'] = { level = 2, kills = 125, upgrade = 3, description = 'LEVEL 2: PILLAR 600 HP'},
	['LEVEL 3'] = { level = 3, kills = 300, upgrade = 7, description = 'LEVEL 3: ASSAULT BOT 1400 HP'},
	['LEVEL 4'] = { level = 4, kills = 400, upgrade = 7, description = '',hero='urs0201',hp=50000, hero_name='Salem Destructor: ', hero_desc=": Salem Destructor Has Arrived"},
	['LEVEL 5'] = { level = 5, kills = 500, upgrade = 15, description = 'LEVEL 4: ASSAULT BOT 3000 HP',},
	['LEVEL 6'] = { level = 5, kills = 600, upgrade = 15, description = '',hero='ual0401', hp=250000, hero_name='Galactic Colossus: ',hero_desc=": Galactic Colossus Has Arrived"},
	['LEVEL 7'] = { level = 6, kills = 800, upgrade = 15, description = '',hero='URL0402', hp=500000, hero_name='Lord of Monkey Lords: ',hero_desc=": Lord of Monkey Lords Has Arrived"},
	['LEVEL 8'] = { level = 7, kills = 1000, upgrade = 30, description = 'LEVEL 5: FINAL UNIT 5000HP',hero='ueb2401',hp=1000000, hero_name='Marvor : ',hero_desc=": Final Units Marvor Has Arrived"},
	['LEVEL 9'] = { level = 7, kills = 3000, upgrade = 30, description = '',hero='uaa0310',hp=1000000, hero_name='Czar : ',hero_desc=": Allmighty Czar Has Arrived... game will end soon!"},
}

		
		
local unitUpgradeList = {
	['LEVEL 0'] = 'UEL0106',--level 0: mech marine
	['LEVEL 1'] = 'UEL0201',--level 1: striker
	['LEVEL 2'] = 'UEL0202',--level 2: pillar
	['LEVEL 3'] = 'UEL0303',--level 3: assault bot
	['LEVEL 4'] = 'UEL0303',--level 4: assault bot
	['LEVEL 5'] = 'ual0303',--level 4: assault bot	
	['LEVEL 6'] = 'ual0303',--level 5: assault bot	
	['LEVEL 7'] = 'ual0303',--level 5: assault bot
	['LEVEL 8'] = 'uel0304',--level 5: assault bot
	['LEVEL 9'] = 'uel0304',
	
}


--create areas on the map
local zones = {}
local xzonesize = 64
local yzonesize = 64
local xmapsize = 512
local ymapsize = 512
local x = 0
local y = 0

 local xoffset=0
 local yoffset=0

--number of zones on the X axis
local imax = 6 -- math.floor(xmapsize / xzonesize)
--number of zones on the Y axis
local jmax = 6 --math.floor(ymapsize / yzonesize)







--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~UTILITY FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--given a player returns an army
toArmy = function(player)
	local army = false
	for i,v in armyTable do
		if v == player.name then
			army = i
		end
	end
	return army
end


--given a player returns a proper username
username = function(player)
	return GetArmyBrain(toArmy(player)).Nickname
end

--given a player returns the number of kills
armyKills = function(player)
	local kills = 0
	if player.name != 'neutral' then 
		local army = toArmy(player)
		kills = GetArmyBrain(army):GetArmyStat('Enemies_Killed',0.0).Value 
	end
	return kills	
end

--print a text scn way :p
--first arg is the text to print
--second arg is what player it concerns
--third arg is if it has to be printed to that player only or to all players
scnPrint = function(text,player,playeronly)

	local army = toArmy(player)
	local colorIndex = ScenarioInfo.ArmySetup[army].PlayerColor
	local color = import('/lua/GameColors.lua').GameColors.ArmyColors[colorIndex]

	-- WARN(army)
	-- WARN(GetFocusArmy())
	-- WARN(color)
	-- WARN(text)
	
	if not playeronly then
		playerspecific = false
	else
		playerspecific = playeronly
	end
	
	
	if playerspecific == true then
		if army == indexToArmy(GetFocusArmy()) then
			PrintText(text,14,color,spawnBeatTime,'center') 
		end
	else
		PrintText(text,14,color,spawnBeatTime,'center') 
	end
end

--given a unit returns the army
scnArmy = function(unit)
	local armyIndex = unit:GetArmy()
	return indexToArmy(armyIndex)
end

--given an army index returns an army
--more efficient but does not work yet
indexToArmy = function(armyIndex)
	local army = ListArmies()[armyIndex]
	return army
end

--get the number of players
playerCount = function()
	local i = 0
	for index, player in players do
		i = i + 1
	end
	return i
end








--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~MAIN SCRIPT FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--populating
function OnPopulate()
	InitializeArmies()
    ScenarioFramework.SetPlayableArea('Playfield', false)
	import('/lua/SimUtils.lua').GiveUnitsToPlayer = function() end
	import('/lua/SimUtils.lua').SetResourceSharing = function() end
	import('/lua/aibrain.lua').OnCreateAI = function(self, planName)
		LOG("aaaaaaaaaaaaaaaaaaaaaa")
	end
	import('/lua/aibrain.lua').ExecuteAIThread = function(self) end
	import('/lua/aibrain.lua').EvaluateAIPlanList = function(self) end
	import('/lua/aibrain.lua').ExecutePlan = function(self) end
	import('/lua/AI/aiarchetype-easy.lua').ExecutePlan = function(self) end
	import('/lua/AI/aiarchetype-medium.lua').ExecutePlan = function(self) end
	import('/lua/AI/aiarchetype-balanced.lua').ExecutePlan = function(self) end
end


--start of map script
function OnStart(self)
	-- force victory condition to sandbox
	ScenarioInfo.Options.Victory = 'sandbox'

	-- set score calculation to show total kills
	for index, brain in ArmyBrains do
	   brain.CalculateScore = function(thisBrain)
		   return thisBrain:GetArmyStat("Enemies_Killed", 0.0).Value
	   end
	end 
   
	--initialise scenario
	--ScenarioFramework.SetPlayableArea('Playfield', false)
	Utilities.UserConRequest("ui_ForceLifbarsOnEnemy")--show enemy life bars
	initialiseZones()
	
	--initialise player zone control
	for index, player in players do
		if player.startLocation != nil then
			changeOwner(zones[player.startLocation[1]][player.startLocation[2]],player.name)
		end
	end
	
	--spawn start bunkers
	spawnBunkers()
	
	--spawn start info units
	spawnUtilityUnits()

	for index, player in players do
	   if player.name!="neutral" then
			createACU(player)
			SetArmyEconomy(toArmy(player),500,1500)
		end
	 end
	--fix_team()
	--start the different scenario threads
	startScenarioThreads()
end

function createACU(player)

		local start = GetMarker(toArmy(player)) 	
		for i=0,4 do
			local unit = CreateUnitHPR( unitUpgradeList['LEVEL 0'] ,toArmy(player), start.position[1]+i-2,25,start.position[3]+i-2, 0,0,0)	
				addKillCount(unit)
				unit:DestroyShield()
				unit:SetMaxHealth(250)
				unit:SetHealth(nil,250)
				unit:GetBlueprint().Wreckage.WreckageLayers.Land=false
				for j = 1, unit:GetWeaponCount() do
					unit:GetWeapon(j):AddDamageMod(5*player.attack)
				end	
				unit:SetSpeedMult(4)
				unit:SetAccMult(3)       
				unit:SetTurnMult(3)
		end
		player.ACU = CreateUnitHPR( ACU_unit, toArmy(player),  start.position[1]+1,25, start.position[3]-1, 0,0,0) 
		player.ACU:SetAllWeaponsEnabled(false)	
		player.ACU:SetCanBeKilled(true)
		--player.ACU:SetDoNotTarget(true)
		player.ACU:SetMaxHealth(8000)
		player.ACU:SetHealth(nil,8000)
		player.ACU:SetRegenRate(80)
		player.ACU:SetSpeedMult(10)
		player.ACU:SetAccMult(3)
		player.ACU:SetTurnMult(4)
		player.ACU:SetBuildRate(50)
		player.ACU:SetReclaimable(false)
		player.ACU:SetConsumptionPerSecondEnergy(5)
		player.ACU:SetConsumptionPerSecondMass(1)
		player.ACU:SetConsumptionActive(false)
		
		player.ACU:SetProductionPerSecondEnergy(5000)
		player.ACU:SetProductionPerSecondMass(500)
		player.ACU:SetProductionActive(false)
		
		--RestrictEnhancements( table )
		local tb={}
		table.insert(tb,player.ACU)
		--[[      local order = {
                    TaskName = "EnhanceTask",
                    Enhancement = 'AdvancedEngineering'
                }
                IssueScript(tb, order)
	--	IssueEnhance(tb,'AdvancedEngineering') ]]
		player.ACU:CreateEnhancement('AdvancedEngineering')
		--import('/lua/sim/Unit.lua').
		player.ACU:SetCustomName(username(player) .. ': Builder')
		for i = 1, player.ACU:GetWeaponCount() do
			--LOG("------------------------------------------++")
			player.ACU:GetWeapon(i):SetEnabled(false) --ChangeMaxRadius(3000)
			--player.ACU:GetWeapon(i):ChangeMaxRadius(5)
			--player.ACU:GetWeapon(i):AddDamageMod(50)
			--player.ACU:GetWeapon(i):AddDamageMod(5)
		end
		
		player.ACU.OldOnKilledUnit = player.ACU.OnKilledUnit
		player.ACU.OnKilledUnit = function(self, unitKilled)
			local player = players[armyTable[scnArmy(self)]]
			local enemy = players[armyTable[scnArmy(unitKilled)]]
			--if the unit did not commit suicide		
			if self:GetArmy() != unitKilled:GetArmy() then 
				player.kills = player.kills + 1
				SetArmyEconomy(toArmy(player),30*mass_earn,30*energy_earn)
			--updateInfo(player)					
			end
			player.ACU.OldOnKilledUnit(self, unitKilled)	
		end		
end

--creates the different threads 
startScenarioThreads = function()
	--start main thread
	local mainThread = ForkThread(function(self)
		while gameEnd == false do
			--call main thread beat
			mainThreadBeat()
			--wait time between each beat
			WaitSeconds(mainBeatTime)
		end
		KillThread(self)
    end)
	
	--check for upgrades in a separate thread for better reaction time
	local spawnThread = ForkThread(function(self)
		while gameEnd == false do
			--call spawn thread beat
			spawnThreadBeat()
			--wait time between each beat
			--[[ if turn<20 then
				WaitSeconds(spawnBeatTime/2)
			elseif turn<40 then
				WaitSeconds(spawnBeatTime*.8)
			else ]]
				WaitSeconds(spawnBeatTime*.6)			
			--end
			--increment beat count
			beat = beat + 1
		end
		KillThread(self)
	end)
	
	local brainThread = ForkThread(function(self)
	while gameEnd == false do
			--call spawn thread beat
			brainThreadBeat()
			--wait time between each beat
			WaitSeconds(brainBeatTime)			
			--increment beat count
		end
		KillThread(self)
	end)
end

--MAIN SCENARIO THREAD
--do map script actions every TICK
--this thread does all the checking of upgrade requests, zone ownership change and victory conditions?
mainThreadBeat = function()
	checkUpgrades()			
	checkZones()
	make_defence_cost()
	checkVictoryConditions()
	checkPD2()
	copyPlayerInfo()
	--SetArmyEconomy('ARMY_5',500,1000)
end

--this thread spawns units
spawnThreadBeat = function()
	turn=turn+1
	spawnUnits()
end

brainThreadBeat = function()
	attackPlayers()
end

--copy the map script variables into the aibrains so that the zone control ai can use them
copyPlayerInfo = function()
	for i, player in players do
		GetArmyBrain(toArmy(player)).ZCInfo = table.copy(players)
	end
end
function display_team()
	local team={}
	local nbr=0
	for index, player in players do
	   if player.index!=0 then
		local ally=false
		for index2, player2 in team do
			if player!=player2  and IsAlly(player.index_Army,player2[1].index_Army) then
				table.insert(team[index2], player)
				--LOG('Ally in team:',player2[1].name, '    player:',player.name)
				ally=true
			end
		end
		if not ally then
			team[player.name]={}
			table.insert(team[player.name], player)
			--LOG('Not Ally:',player.name)
		end
	   end
	end
	LOG("-- Teams detected --")
	LOG("-+-+-+-+-+-+-+-+-+-+")
	
	for i,j in team do
		LOG(j[1].name)
		for ii,jj in j do
			LOG('     ',jj.name)
		end
	end 
	return team
end


--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~MAIN THREAD FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--check for end game conditions
checkVictoryConditions = function()
	if first_time then fix_team() first_time=false end
	local team={}
	local zone_control_team={}
	local nbr=0
	for index, player in players do
		if player.name!='neutral' then
			if player.index!=0 then
				local ally=false
				for index2, player2 in team do
					if player!=player2  and IsAlly(player.index_Army,player2[1].index_Army) then
						table.insert(team[index2], player)
						zone_control_team[index2]=zone_control_team[index2]+player.zonecontrol
						--LOG('Ally in team:',player2[1].name, '    player:',player.name)
						ally=true
					end
				end
				if not ally then
					team[player.name]={}
					zone_control_team[player.name]=player.zonecontrol
					table.insert(team[player.name], player)
					--LOG('Not Ally:',player.name)
				end
			end
		end
	end
	local victory=true
	local best_team=-1
	for index, team_name in team do
		if zone_control_team[index]<=0 then
			for i,player in team_name do
				if player.defeated == false and player.name != 'neutral' then
					player.defeated=true
					GetArmyBrain(toArmy(player)):OnDefeat()
				end
			end
		else
			if best_team==-1 then 
				best_team=index
			else
				-- several team alive
				victory=false
			end
		end
	end
	
	if victory then
		for i,player in team[best_team] do
			GetArmyBrain(toArmy(player)):OnVictory()
		end
		gameEnd = true
		return
	end

end

function attackPlayer_units(units,player,x,y)
	local xoff =  -2 + math.random(0,1)*4
	local yoff =  -2 + math.random(0,1)*4
	local aiBrain = GetArmyBrain(toArmy(player))
	if table.getn(units) > 0 then
		if player.ai.att_platoon!= false and GetArmyBrain(toArmy(player)):PlatoonExists(player.ai.att_platoon) then
			player.ai.att_platoon:Stop()
			aiBrain:DisbandPlatoon(player.ai.att_platoon)
		end
		player.ai.att_platoon = aiBrain:MakePlatoon('','')

		aiBrain:AssignUnitsToPlatoon(player.ai.att_platoon, units, 'Attack', formation_used)
		player.ai.att_platoon:MoveToLocation({x+xoff,25,y+yoff},false)
		player.ai.att_platoon:Patrol({x+xoff+2,25,y+yoff+2})
		player.ai.att_platoon:Patrol({x+xoff,25,y+yoff+2})
		player.ai.att_platoon:Patrol({x+xoff+2,25,y+yoff})
	end
end

function attackPlayer(player,x,y,createplatoon)
	if toArmy(player)==nil or toArmy(player)==false or toArmy(player)=="Neutral" then return end
	local brain = GetArmyBrain(toArmy(player))
	if brain==nil or brain==false then return end
	local xoff =  -2 + math.random(0,1)*4
	local yoff =  -2 + math.random(0,1)*4
	if createplatoon or not brain:PlatoonExists(player.ai.att_platoon) or player.ai.att_platoon==false or player.ai.att_platoon==nil then 
		if brain:PlatoonExists(player.ai.att_platoon) and player.ai.att_platoon!= false then
			player.ai.att_platoon:Stop()
			brain:DisbandPlatoon(player.ai.att_platoon)
		end
		player.ai.att_platoon = brain:MakePlatoon('','')
		local units=brain:GetListOfUnits(att_cat,true)
		brain:AssignUnitsToPlatoon(player.ai.att_platoon, units, 'Attack', formation_used)
	else
		if brain:PlatoonExists(player.ai.att_platoon) and player.ai.att_platoon!= false then
			player.ai.att_platoon:Stop()
		end	
	end
	player.ai.att_platoon:MoveToLocation({x+xoff,25,y+yoff},false)
	player.ai.att_platoon:Patrol({x+xoff+2,25,y+yoff+2})
	player.ai.att_platoon:Patrol({x-xoff,25,y+yoff+2})
	player.ai.att_platoon:Patrol({x+xoff+2,25,y-yoff})
end

function find_easy_spot(player,x_start,y_start,radius_search,bally,bmin)
	local pop=0
	local min_pop={val=500000,x=-1,y=-1}
	if not bmin then min_pop.val=-10 end
	local a=0
	local b=0
	for i=-1*radius_search,radius_search do
		for j=-1*radius_search,radius_search do
			if not(i==0 and j==0) then
				a=x_start+i
				b=y_start+j
				if a>imax then a=imax end if a<1 then a=1 end
				if b>jmax then b=jmax end if b<1 then b=1 end
				if not(a==1 and b==1) and not (a==imax and b==1) and not (a==1 and b==jmax) and not(a==imax and b==jmax)
				   and ( IsAlly(toArmy(player),toArmy(owner(zones[a][b])))==bally) and not(a==x_start and b==y_start) then
					pop=table.getsize(GetUnitsInRect(Rect((a)*64,(b)*64,(a)*64+64,(b)*64+64)))
					if pop!=nil and GetArmyBrain(toArmy(owner(zones[a][b]))).BrainType=="AI" then  pop=pop*player.ai.agressivity_against_human end
					if pop!=nil then pop=pop*((i*i+j*j)) end
					if pop!=nil and (bmin and min_pop.val>pop) or (not bmin and min_pop.val<pop) then 
						min_pop.val=pop
						min_pop.x=a
						min_pop.y=b	
					end
					if pop==nil then pop=-2 end
				else
					pop=-1
				end
				
			end
		--LOG(a,' ',b,'    ',pop,  "   ",toArmy(player),"  ",toArmy(owner(zones[a][b])))
		end
	end
	if min_pop.val==500000 then min_pop.val=-1 end
	return min_pop
end

function check_ally_zone(player, x,y)
	if toArmy(player)==nil or toArmy(owner(zones[x][y]))==nil or toArmy(player)==false or toArmy(owner(zones[x][y]))==false then return nil end
	return IsAlly(toArmy(player),toArmy(owner(zones[x][y])))
end

function attackPlayers()
	for i, player in players do
		if player.name!="neutral" and player.name!=nil then
			local brain = GetArmyBrain(toArmy(player))
			if brain.BrainType=="AI" and ((math.mod(turn,player.ai.vivacity)==0 ))then

				if GetArmyBrain(toArmy(player)):GetEconomyStored('ENERGY') >= (player.attack + 1)*500*2 then	upgradeAttack(player) end
				if GetArmyBrain(toArmy(player)):GetEconomyStored('MASS') >= (player.defence + 1)*100*2 then	upgradeDefence(player) end
				
				-- ====================================== script part
				if player.ai!=nil and player.ai["attack_plan"..player.ai.step]!=nil and player.ai.start then
					local units=brain:GetListOfUnits(categories.TECH1-categories.STRUCTURE-categories.CYBRAN,true)
					--LOG(player.ai["attack_plan"..player.ai.step])
					local cont=true
					local step_sav=player.ai.step
					while cont and player.ai.step<max_ai_step do
						if not player.ai["attack_plan"..player.ai.step].wait_ctr or IsAlly(toArmy(player),toArmy(owner(zones[math.floor(player.ai["attack_plan"..player.ai.step].x_obj)][math.floor(player.ai["attack_plan"..player.ai.step].y_obj)]))) then
							--LOG("zone controlled")
							player.ai.step=player.ai.step+1
						elseif player.ai["attack_plan"..player.ai.step].skipifenemy!=nil and player.ai["attack_plan"..player.ai.step].skipifenemy and owner(zones[math.floor(player.ai["attack_plan"..player.ai.step].x_obj)][math.floor(player.ai["attack_plan"..player.ai.step].y_obj)]).name!="neutral" then
							--LOG("zone skipped")
							player.ai.step=player.ai.step+1
						else
							cont=false
						end
					end
					if player.ai.step>=max_ai_step then LOG(" -------- ", player.name,' ended script part') player.ai.start=false end
				
					if (step_sav!=player.ai.step or player.ai.step==1 or math.mod(turn,4)) and player.ai["attack_plan"..player.ai.step]!=nil and table.getsize(units)>=player.ai["attack_plan"..player.ai.step].min_trp then
						attackPlayer_units(units, player,32+64*player.ai["attack_plan"..player.ai.step].x,32+64*player.ai["attack_plan"..player.ai.step].y)
						--if player.name=="player5" then LOG(player.name, "  order given") end
					end
				else -- ================================= start phase ended
					-- objectif attein ?

				if player.ai.danger and (player.ai.objectif_timer+turn_of_alert)>(turn) then
					player.ai.danger=false
					player.ai.objectif_define=false
				end
						
				
					if player.ai.objectif_define then
						danger=GetArmyBrain(toArmy(player)):GetUnitsAroundPoint(categories.STRUCTURE*categories.TECH2*categories.DEFENSE*categories.UEF,{player.ai.objectif_x*64+32,25,player.ai.objectif_y*64+32}, player.ai.rangePD,'Enemy')
					
						if table.getsize(danger)>0 then
							player.ai.danger=true
							player.ai.objectif_define=false
							player.ai.objectif_timer=turn
							attackPlayer(player,danger[1]:GetPosition()[1],danger[1]:GetPosition()[3],true)
							LOG(" @@ ", player.name," danger! PD T2 detected at ",danger[1]:GetPosition()[1]," , ",danger[1]:GetPosition()[3])
						else
							player.ai.danger=false
						end
					end
					
				if not player.ai.danger then	
					if player.ai.objectif_define  and GetArmyBrain(toArmy(player)):PlatoonExists(player.ai.att_platoon)
						and (table.getsize(player.ai.att_platoon:GetPlatoonUnits())<attack_size_min  
						or  check_ally_zone(player,player.ai.objectif_x,player.ai.objectif_y)) 
						or turn>player.ai.objectif_timer+ player.ai.skip_objectif then
						player.ai.objectif_define=false
						 player.ai.att_platoon=false
						 if check_ally_zone(player,player.ai.objectif_x,player.ai.objectif_y)  then
							LOG(" ^ ", player.name," succeed objectif!")
						 else
							LOG(" x ", player.name," abandon objectif")
						end
					end
					-- no platoon, create
					if player.ai.att_platoon==false or player.ai.att_platoon==nil or not GetArmyBrain(toArmy(player)):PlatoonExists(player.ai.att_platoon)then
						player.ai.objectif_define=false
						player.ai.att_platoon=GetArmyBrain(toArmy(player)):MakePlatoon('','')
						player.ai.def_platoon=GetArmyBrain(toArmy(player)):MakePlatoon('','')
						local units=brain:GetListOfUnits(att_cat,true)
						GetArmyBrain(toArmy(player)):AssignUnitsToPlatoon(player.ai.att_platoon, units, 'Attack', formation_used)
						LOG(" * ", player.name, "  create new army") 
					end
					
					if player.ai.objectif_define==false  then
						-- no objectif and minimum army size

						-- find min enemy population point (the weakest)
						local pop=find_easy_spot(player,player.ai.x_obj,player.ai.x_obj,player.ai.intel_look,false,true)

						if pop.val>0 then 
							-- objectif find so attack
							player.ai.objectif_x=pop.x
							player.ai.objectif_y=pop.y
							attackPlayer(player,player.ai.objectif_x*64+32,player.ai.objectif_y*64+32,false)
							player.ai.objectif_define=true
							player.ai.objectif_timer=turn
							LOG(" + ", player.name," attack   x=",player.ai.objectif_x," , y=",player.ai.objectif_y,'  army size:',table.getsize(player.ai.att_platoon:GetPlatoonUnits()))
						else
							-- no objectif find so redine start attack point and move				
							
							-- find max ally population point (the strongest)
							local radius=2
							local pop2=-1
							while ((pop2.val<=0 ) or ((player.ai.old_house_x==pop2.x) and (player.ai.old_house_y==pop2.y))
							   or ((player.ai.x_obj==pop2.x) and (player.ai.y_obj==pop2.y))) and radius<6 do
								pop2=find_easy_spot(player,player.ai.x_obj,player.ai.x_obj,radius,true,false)
								LOG(" s ", player.name," search new house... radius: ",radius)
								radius=radius+1
							end
							if pop2.val>0 then 
								player.ai.old_house_x=player.ai.x_obj
								player.ai.old_house_y=player.ai.y_obj
								player.ai.x_obj=pop2.x
								player.ai.y_obj=pop2.y
								player.ai.objectif_define=false
								attackPlayer(player,player.ai.x_obj*64+32,player.ai.y_obj*64+32,true)
								LOG(" o ", player.name, " move to ",player.ai.x_obj," , ",player.ai.y_obj, ' and recreate new army')
							else
								attackPlayer(player,player.ai.x_obj*64+32,player.ai.y_obj*64+32,true)
								LOG(" ? ", player.name," difficulties aleatory move... at ",player.ai.x_obj,' , ',player.ai.y_obj)
							end
						end
					end -- danger
					else
						--LOG("not ready to attack")
					end
				end
				--end
				
			end
		end
	end
end

--CHECK IF UPGRADES ARE NECESSARY, APPLY THEM
checkUpgrades = function()

	--Check for kill triggered upgrades
	for levelindex,level in upgradeList do
		for index,player in players do
			if armyKills(player) >= level.kills then
				upgrade(player,levelindex)
			end
		end
	end
	
	--Check for area triggered upgrades
	checkUpgradeRequests()
end



--SPAWN UNITS ON ALL ZONES DEPENDING ON OWNERSHIP
spawnUnits = function()
	local i = 1
	while i <= imax do
		local j = 1
		while j <= jmax do
			if (i > 1 and i < imax) or (j > 1 and j<jmax) then
			spawnUnit(zones[i][j])
			end
			j = j + 1
		end
		i = i + 1
	end	
end


--SPAWN BUNKERS AT START
spawnBunkers = function()
	--if true then return end -- :P
	local i = 1
	while i <= imax do
		local j = 1
		while j <= jmax do
			if (i > 1 and i < imax) or (j > 1 and j<jmax) then
			spawnBunker(zones[i][j])
			end
			j = j + 1
		end
		i = i + 1
	end	
end

--CHECK OWNERSHIP ON ALL ZONES
checkZones = function()
	local i = 1
	while i <= imax do
		local j = 1
		while j <= jmax do
			if (i > 1 and i < imax) or (j > 1 and j<jmax) then
			checkZone(zones[i][j])
			end
			j = j + 1
		end
		i = i + 1
	end	
end

--make all zones
initialiseZones = function()
	local i = 1
	while i <= imax do		
		local j = 1
		zones[i] = {}
		bunkerDeath[i] = {}
		while j <= jmax do
			if (i > 1 and i < imax) or (j > 1 and j<jmax) then
				zones[i][j] = createZone(i,j)
			end
			j = j + 1
		end
		i = i + 1

	end
end


function checkPD2()
	for i, player in players do
		--LOG(player.name)
		if player.name!="neutral" and player.name!=nil then
			local brain = GetArmyBrain(toArmy(player))
			local units=brain:GetListOfUnits(categories.TECH2*categories.DEFENSE*categories.STRUCTURE,true) --categories.UEB2301, false)
			--LOG(table.getsize(units))
			for index, unit in units do
				if unit.checked==nil and not( unit:IsBeingBuilt()) and  not (unit.checked) then
					bucker_caract_lvl2(unit,player)
					addBunkerKillCount(unit)
					--LOG("checked")
					unit.checked=true
				end
			end
		end
	end
--	brain:GetListOfUnits(categories, boolean)
end

function make_defence_cost()
	for i, player in players do
		if player.defenceUnit!=nil and  player.defenceUnit!=false and player.name!=nil and player.name!="neutral" and  player.zonecontrol>=0 then
			player.defenceUnit:SetConsumptionPerSecondEnergy(player.zonecontrol*cost_zone_Energy)
			player.defenceUnit:SetConsumptionPerSecondMass(player.zonecontrol*cost_zone_Mass)
		end
	end
end







--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ZONE MANAGING FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
--zone constructor
createZone = function(i,j)
	--create zone at (i, j) coordonates
	local zone =  {owner = 'neutral', x = i, y = j, Xsize = xzonesize, Ysize = yzonesize, hasBunker = false}
	
	--create zone rectangle
	zone.rectangle = {}
	zone.rectangle.x0 = (zone.x ) * zone.Xsize  + xoffset
	zone.rectangle.y0 = (zone.y ) * zone.Ysize  + yoffset
	zone.rectangle.x1 = zone.rectangle.x0 + zone.Xsize
	zone.rectangle.y1 = zone.rectangle.y0 + zone.Ysize
	
	--generate ,bunker death trigger functions
	bunkerDeath[i][j] = function()		
		--acknowledge bunker destruction and refresh zone count
		zone.hasBunker = false
		removeZone(zone.owner)		
	end

	return zone
end

--given a zone, returns the position of its center
zoneCenter = function(zone)
	local center = {}
	center.x = (zone.x+1) * zone.Xsize - ( zone.Xsize / 2) + xoffset
	center.y = (zone.y +1)* zone.Ysize - ( zone.Ysize / 2) + yoffset
	return center
end


--change the owner of a zone
changeOwner = function(zone,newowner)
	zone.owner = newowner
end

--returns the player that owns the zone
owner = function(zone)
	return players[zone.owner]
end


--CHECK ZONE OWNERSHIP, CHANGE IT IF NECESSARY
checkZone = function(zone)
	--IF ZONE CONTAINS A BUNKER DO NOT CHECK: DONE
	--IF ZONE CONTAINS ONLY UNITS FROM 1 PLAYER AND PLAYER != OWNER THEN OWNER = PLAYER	
	--CREATE A BUNKER FOR THE NEW OWNER: DONE	
	
	--if zone does not have a bunker
	if zone.hasBunker == false then --and zone.owner == 'neutral' then
		--find new owner
		local ownerfound = refreshOwner(zone)
		--spawn bunker on zone
		if zone.owner != 'neutral' and ownerfound == true then
		spawnBunker(zone)		
		--add zone to owner
		addZone(zone.owner)		
		end

	end	

end

--FIND NEW OWNER FOR ZONE
refreshOwner = function(zone)
	local ownerfound = false
	
	--LOG(repr(zone.rectangle))
	
	local ally = toArmy(owner(zone))	
	local count = { ['ARMY_1'] = 0, ['ARMY_2'] = 0, ['ARMY_3'] = 0, ['ARMY_4'] = 0, ['ARMY_5'] = 0, ['ARMY_6'] = 0, ['ARMY_7'] = 0, ['ARMY_8'] = 0,['ARMY_9'] = 0}
	local enemyCount = 0
	local allyCount = 0
	
	--get units in zone
	local unitsInZone = GetUnitsInRect(zone.rectangle)
	

	
	--get army counts in zone
	if unitsInZone then
		for k,unit in unitsInZone do
			if not unit:IsDead()  then
				local army = ''
				if unit:GetArmy() == playerCount() then
					army = 'ARMY_9'
				else
					army = scnArmy(unit)
				end
				
				count[army] = count[army] + 1
				if army != ally and IsAlly(ally, army) == false then 
					enemyCount = enemyCount + 1
				else
					allyCount = allyCount + 1
				end
			end
		end
	end
	
	--determine new owner depending on army count
	--zone owner retakes ownership
	if allyCount >= 10 and enemyCount == 0 then
		ownerfound = true
	--attacker captures zones
	elseif allyCount <= 5 then
		local maxcountArmy = false
		local maxvalue = 0
		local draw = false
		
		--find army with most troops on zone
		for army,value in count do 
			if maxcountArmy == false then
				maxcountArmy = army
			end
			if value > maxvalue then
				maxvalue = value
				maxcountArmy = army
			elseif value == maxvalue and value != 0 then
				draw = true
			end
		end
		
		--if the army with more troops has more than 5 troops then capture the zone
		if count[maxcountArmy] >= 5 and draw == false then
			zone.owner = armyTable[maxcountArmy]
			ownerfound = true
		end
		
		
	end
	
	return ownerfound
end


--add zone to count of player
addZone = function(playername)
	players[playername].zonecontrol = players[playername].zonecontrol + 1
	zone_add=zone_add+1
	--instigator:GetAIBrain():GiveResource('MASS', mamount) 
	--armyTable:GetAIBrain():GiveResource('ENERGY', eamount) 
	--GetArmyBrain(toArmy(players[playername])):GiveResource('MASS', 1) 
	--LOG("" .. players[player].name .."ZONE CONTROL: " .. players[player].zonecontrol)
end

--remove zone from count of player
removeZone = function(playername)
	players[playername].zonecontrol = players[playername].zonecontrol - 1
	--GetArmyBrain(toArmy(players[playername])):TakeResource('MASS', 1) 
	--self:GetAIBrain():TakeResource('Energy', self:GetBlueprint().Economy.StorageEnergy) 
	--LOG("" .. players[player].name .."ZONE CONTROL: " .. players[player].zonecontrol)
end

--returns a valid spot to spawn a unit for a player in case he doesnt own his start location anymore
findZone = function(player)
	local startzone = zones[player.startLocation[1]][player.startLocation[2]]
	local properzone = startzone
	
	--if the player does not own his start zone anymore
	if startzone.owner != player.name then
		local mindistance = VDist2(1,1,imax,jmax) --initialise the minimum distance with the maximum value
		
		for i,zoneline in zones do
			for j,zone in zoneline do --calculate the minimal distance and save the corresponding zone
				if zone.owner == player.name then
					zonedistance = VDist2(startzone.x, startzone.y, i, j)--math.sqrt( (i-startzone.x)*(i-startzone.x) + (j - startzone.y)*(j - startzone.y))
					if  zonedistance < mindistance then
						properzone = zone
						mindistance = zonedistance
						--LOG("temp min distance: " .. mindistance .. " for zone(" .. zone.x .. ")(".. zone.y .. ")")
					end
				end
			end
		end
	end
	
	return properzone
end






--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~UNIT SPAWNING FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


--spawns a bunker on a zone
spawnBunker = function(zone)
	--SPAWN UNIT ON ZONE DEPENDING ON PLAYER OWNERSHIP
	--SPAWN NO UNIT IF ZONE IS NEUTRAL
	local x = zoneCenter(zone).x
	local y = zoneCenter(zone).y
	local player = owner(zone)
	local army = toArmy(player)
	
	zone.bunker = false
	
	--spawn bunker if not population limit
	if (GetArmyUnitCostTotal(GetArmyBrain(army):GetArmyIndex()) +2)< GetArmyUnitCap(GetArmyBrain(army):GetArmyIndex()) then		
		if zone.x == player.startLocation[1] and zone.y == player.startLocation[2] then
			zone.bunker = CreateUnitHPR( 'uab5103', toArmy(player), x,y,y, 0,0,0)
		--	zone.bunker2 = CreateUnitHPR( 'uab5103', player_equivalent[toArmy(player)], x,y,y, 0,0,0)
		--	ScenarioFramework.CreateUnitDeathTrigger(bunkerDeath[zone.x][zone.y],zone.bunker2)
			
			--'ueb2301', toArmy(player), x,y,y, 0,0,0) 
		else
			zone.bunker = CreateUnitHPR( player.bunkerType, toArmy(player), x,y,y, 0,0,0) 
			zone.bunker:GetWeapon(1):ChangeMaxRadius(35)
			zone.bunker:GetBlueprint().Wreckage.WreckageLayers.Land=false

		end

	end
	
	--if bunker exists apply balance changes and upgrades
	if zone.bunker != false then
		zone.hasBunker = true
		
		if zone.owner == 'neutral' then 
			zone.bunker:SetMaxHealth(500)
			zone.bunker:SetHealth(zone.bunker,500)
		else
			bucker_caract(zone.bunker,player)
			
			addBunkerKillCount(zone.bunker)
		end
		
		
				--disable wreckage
		
				--death trigger
		ScenarioFramework.CreateUnitDeathTrigger(bunkerDeath[zone.x][zone.y],zone.bunker)
	end

end

function bucker_caract(bunker,player)
	bunker:SetMaxHealth(1000 + 700*player.defence)
	bunker:SetHealth(nil,1000 + 700*player.defence)
	bunker:SetRegenRate(2*(player.defence+1))
	bunker:SetReclaimable(false)	
													
	for i = 1, bunker:GetWeaponCount() do
		bunker:GetWeapon(i):ChangeRateOfFire(1 + player.defence/6)
		bunker:GetWeapon(i):AddDamageMod(6*player.defence + 2*player.defence*player.defence)
	end
	bunker:SetCustomName(username(player) .. ', level ' .. player.defence)
end

function bucker_caract_lvl2(bunker,player)
	bunker:SetMaxHealth(3000 + 800*player.defence)
	bunker:SetHealth(nil,3000 + 800*player.defence)
	bunker:SetRegenRate(4*(player.defence+1))
	bunker:SetReclaimable(false)	
													
	for i = 1, bunker:GetWeaponCount() do
		bunker:GetWeapon(i):ChangeRateOfFire(1.2 + player.defence/3)
		bunker:GetWeapon(i):AddDamageMod(12*player.defence + 3*player.defence*player.defence)
	end
	bunker:SetCustomName(username(player) .. ', level ' .. player.defence)
end
--ADD A KILL COUNT TO A BUNKER
--defender gets more money than attacker, a kill made by a bunker gives 10 instead of 5 for a regular kill
addBunkerKillCount = function(unit)
	--kill count
	unit.OldOnKilledUnit = unit.OnKilledUnit
	unit.OnKilledUnit = function(self, unitKilled)
		local player = players[armyTable[scnArmy(self)]]
		local enemy = players[armyTable[scnArmy(unitKilled)]]
		--if the unit did not commit suicide		
		if self:GetArmy() != unitKilled:GetArmy() then 
			player.kills = player.kills + 1
			if enemy.level == 2 then
				--player.money = player.money + 15
				SetArmyEconomy(toArmy(player),2*mass_earn,2*energy_earn)
			elseif enemy.level >= 4 then
				--player.money = player.money + 150
				SetArmyEconomy(toArmy(player),20*mass_earn,20*energy_earn)
			elseif enemy.level == 3 then
				--player.money = player.money + 35
				SetArmyEconomy(toArmy(player),4*mass_earn,4*energy_earn)
			else
				--player.money = player.money + 10
				SetArmyEconomy(toArmy(player),mass_earn,energy_earn)
			end
			updateInfo(player)					
		end
		unit.OldOnKilledUnit(self, unitKilled)	
	end		
end


--SPAWN UNIT ON ZONE
spawnUnit = function(zone)
	--SPAWN UNIT ON ZONE DEPENDING ON PLAYER OWNERSHIP
	--SPAWN NO UNIT IF ZONE IS NEUTRAL
	local x = zoneCenter(zone).x
	local y = zoneCenter(zone).y
	local unit = false	
	local unit2=false
	local player = owner(zone)
	--local player=players[play]
--	LOG(player.name)
	local army = toArmy(player)
	--LOG("===================", (play))
	local unitType = unitUpgradeList['LEVEL ' .. player.level]
	
	local xside = math.random(0,1)
	local yside = math.random(0,1)
	local xoff = 0
	local yoff = 0
	
   --if zone.hasBunker == false then
	--else
	if zone.owner != 'neutral' and player.name!=nil then
	--LOG("===================", (player))
		--check unit cap to avoid bug		
		--LOG(army)
		function dep_unit(unit,player)
			if unit != false then
				addKillCount(unit)
				unit:DestroyShield()
				unit:SetMaxHealth(200*upgrades(zone)+50*player.attack)
				unit:SetHealth(nil,200*upgrades(zone)+50*player.attack)
				--thanks to UArchitect
				--disable wreckage as way too many of the stuff appears..decals are enough, (wouldnt be so bad if i could make them slowly sink into the ground after a while)
				if unit:GetBlueprint().Wreckage.WreckageLayers.Land!=nil then 
					unit:GetBlueprint().Wreckage.WreckageLayers.Land=false
				end
		
				for i = 1, unit:GetWeaponCount() do
					unit:GetWeapon(i):AddDamageMod(10*player.attack)
				end	
				unit:SetSpeedMult(4)
				unit:SetAccMult(3)       
				unit:SetTurnMult(3)
				unit:SetReclaimable(false)
				--move unit after being created
				--thanks to UArchitect add randomness stuff to the move order
				xoff = -12 + xside*18
				yoff = -12 + yside*18
				xoff = xoff + -2 + math.random(0,1)*4
				yoff = yoff + -2 + math.random(0,1)*4
				IssueMove( {unit}, {x+xoff,25,y+yoff} )

				 if GetArmyBrain(toArmy(player)).BrainType=="AI" and player.ai.att_platoon!= nil and player.ai.att_platoon!=false and GetArmyBrain(toArmy(player)):PlatoonExists(player.ai.att_platoon) then 
					GetArmyBrain(toArmy(player)):AssignUnitsToPlatoon(player.ai.att_platoon, {unit}, 'Attack', formation_used) 
				 else
					if GetArmyBrain(toArmy(player)).BrainType=="AI" then LOG("warn, platoon no (or no more) existing for "..player.name) end
					--if player.name=="player5" then LOG("pb") end
				 end
			end
		end	
		
		
		if not player.defeated and (GetArmyUnitCostTotal(GetArmyBrain(army):GetArmyIndex())+2) < GetArmyUnitCap(GetArmyBrain(army):GetArmyIndex()) then
			--adjust spawn rate depending on level

			if player.level <= 1 then --low level units spawn every tick
					--unit = CreateUnitHPR( unitType, army, x,25,y+3, 0,0,0) 		
					unit = CreateUnitHPR( unitType, army, x+(-1+xside*2),25,y+(-1+yside*2), 0,0,0)	
			elseif player.level == 2 then -- pillars spawn 1 time out of 2
				if math.mod(beat,2) == 0 then
					unit = CreateUnitHPR( unitType, army, x+(-1+xside*2),25,y+(-1+yside*2), 0,0,0)
				end
			elseif player.level>=16 then -- siege bots spawn 1 time out of 4
				if math.mod(beat,4) == 0 then
					unit = CreateUnitHPR( unitType, army, x+(-1+xside*2),25,y+(-1+yside*2), 0,0,0)
				end
			else
				if math.mod(beat,3) == 0 then
					unit = CreateUnitHPR( unitType, army, x+(-1+xside*2),25,y+(-1+yside*2), 0,0,0)
				end
			end
			dep_unit(unit,player)
			
		end
	if player_equivalent[army]!=nil then
		army=player_equivalent[army]
		xside = 1-xside
		yside = 1-yside
		local lvl=players[armyTable[player_equivalent[army]]].level
		--LOG(army)
		if not players[armyTable[player_equivalent[army]]].defeated and (GetArmyUnitCostTotal(GetArmyBrain(army):GetArmyIndex())+2) < GetArmyUnitCap(GetArmyBrain(army):GetArmyIndex()) then
			--adjust spawn rate depending on level
			if lvl <= 1 then --low level units spawn every tick
					unit2 = CreateUnitHPR( unitType, army, x+(-1+xside*2),25,y+(-1+yside*2), 0,0,0)	
			elseif lvl == 2 then -- pillars spawn 1 time out of 2
				if math.mod(beat,2) == 0 then
					--unit = CreateUnitHPR( unitType, army, x,25,y+3, 0,0,0) 	
					unit2 = CreateUnitHPR( unitType, army, x+(-1+xside*2),25,y+(-1+yside*2), 0,0,0)
				end
			elseif player.level>=16 then -- siege bots spawn 1 time out of 4
				if math.mod(beat,4) == 0 then
					unit = CreateUnitHPR( unitType, army, x+(-1+xside*2),25,y+(-1+yside*2), 0,0,0)
				end
			else
				if math.mod(beat,3) == 0 then
					unit = CreateUnitHPR( unitType, army, x+(-1+xside*2),25,y+(-1+yside*2), 0,0,0)
				end
			end
			dep_unit(unit2,players[armyTable[player_equivalent[army]]])
		end	
	
	end
   end	
	--if unit exists apply unit balance changes and upgrades
	
	
	
end



--ADD A KILL COUNT TO A UNIT
addKillCount = function(unit)
	--kill count
	unit.OldOnKilledUnit = unit.OnKilledUnit
	unit.OnKilledUnit = function(self, unitKilled)
		local player = players[armyTable[scnArmy(self)]]
		local enemy = players[armyTable[scnArmy(unitKilled)]]
--		LOG('player:', repr(player))
--		LOG('enemy:', repr(enemy))GetArmyBrain(
		--LOG(GetArmyBrain(self:GetArmy()).Nickname, " has killed one unit of ",GetArmyBrain(unitKilled:GetArmy()).Nickname)
		--if the unit did not commit suicide		
		if self:GetArmy() != unitKilled:GetArmy() then 
			player.kills = player.kills + 1
			if enemy.level == 2 then
				--player.money = player.money + 10
				SetArmyEconomy(toArmy(player),2*mass_earn,2*energy_earn)
			elseif enemy.level >= 4 then
				--player.money = player.money + 150
				SetArmyEconomy(toArmy(player),6*mass_earn,6*energy_earn)
			elseif enemy.level == 3 then
				--player.money = player.money +35
				SetArmyEconomy(toArmy(player),4*mass_earn,4*energy_earn)
			else
				--player.money = player.money + 5
				SetArmyEconomy(toArmy(player),math.floor(1.5*mass_earn),math.floor(1.5*energy_earn))
			end
			--update display
			updateInfo(player)			
			--GetArmyBrain(toArmy(player)):GiveResource('ENERGY', 10000) 		
		end
		unit.OldOnKilledUnit(self, unitKilled)	
	end		
end


--UNIT DEATH TRIGGERS
unitDeath['player1'] = function()
	--players['player1'].deaths = players['player1'].deaths + 1
	WARN('player1')
	WARN('index: ' .. GetArmyBrain(toArmy(players['player1'])):GetArmyIndex())
end

unitDeath['player2'] = function()
	--players['player2'].deaths = players['player2'].deaths + 1
	WARN('player2')
	WARN('index: ' .. GetArmyBrain(toArmy(players['player2'])):GetArmyIndex())
end

unitDeath['player3'] = function()
	--players['player3'].deaths = players['player3'].deaths + 1
	WARN('player3')
	WARN('index: ' .. GetArmyBrain(toArmy(players['player3'])):GetArmyIndex())
end

unitDeath['player4'] = function()
	--players['player4'].deaths = players['player4'].deaths + 1
	WARN('player4')
	WARN('index: ' .. GetArmyBrain(toArmy(players['player4'])):GetArmyIndex())
end









--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~UPGRADE SYSTEM FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

--check for attack or defence upgrade requests in area
checkUpgradeRequests = function()
   for index,player in players do
	 if GetArmyBrain(toArmy(player)).BrainType!="AI" then
		--check for attack upgrade request
		local requestGroupA = {}
		if player.attackUnit != false then
			if GetArmyBrain(toArmy(player)):GetUnitsAroundPoint(categories.MOBILE,player.attackUnit:GetPosition(), 10,'Ally')!=nil  then
				requestGroupA = GetArmyBrain(toArmy(player)):GetUnitsAroundPoint(categories.MOBILE,player.attackUnit:GetPosition(), 10,'Ally')
				if table.getsize(requestGroupA) != 0 then LOG(requestGroupA[1]:GetArmy(),'   ',toArmy(player)) end
				if table.getsize(requestGroupA) != 0 and ("ARMY_"..requestGroupA[1]:GetArmy())==toArmy(player) then
					respawnUpgrader(player)
					upgradeAttack(player)
				end
			end
		end
		
		--check for defence upgrade request
		local requestGroupB = {}
		if player.defenceUnit != false then
			if GetArmyBrain(toArmy(player)):GetUnitsAroundPoint(categories.MOBILE,player.defenceUnit:GetPosition(), 10,'Ally') != nil then
				requestGroupB = GetArmyBrain(toArmy(player)):GetUnitsAroundPoint(categories.MOBILE,player.defenceUnit:GetPosition(), 10,'Ally')
				if table.getsize(requestGroupB) != 0 then LOG(requestGroupB[1]:GetArmy(),'   ',toArmy(player)) end
				if table.getsize(requestGroupB) != 0 and ("ARMY_"..requestGroupB[1]:GetArmy())==toArmy(player) then
					--IssueBlueprintCommand("UNITCOMMAND_BuildFactory", "ueb2301", 1)
					respawnUpgrader(player)
					upgradeDefence(player)
				end
			end
		end
		
		--check for defence upgrade request
		local requestGroupC = {}
		if player.kamikazeShop != false then
			if GetArmyBrain(toArmy(player)):GetUnitsAroundPoint(categories.MOBILE,player.kamikazeShop:GetPosition(), 10,'Ally') != nil then
				requestGroupC = GetArmyBrain(toArmy(player)):GetUnitsAroundPoint(categories.MOBILE,player.kamikazeShop:GetPosition(), 10,'Ally')
			
				if table.getsize(requestGroupC) != 0 and ("ARMY_"..requestGroupC[1]:GetArmy())==toArmy(player) then
					respawnUpgrader(player)
					if (GetArmyUnitCostTotal(GetArmyBrain(toArmy(player)):GetArmyIndex())+1) < GetArmyUnitCap(GetArmyBrain(toArmy(player)):GetArmyIndex()) then
						purchaseKamikaze(player)
					else
						scnPrint(username(player) .. ': unit cap limit: kamikaze can not be bought!',player)
					end
				end
			end
		end
		if player.upgrader!= nil and player.upgrader!= false then
		if player.upgrader:GetPosition()!=nil then
			local x=player.upgrader:GetPosition()[1]
			local y=player.upgrader:GetPosition()[3]
			local lim=5
			if x<(64+lim) or x>(512-64-lim) or (x>(123-lim) and x<(512-123+lim ))
			or y<(64+lim) or y>(512-64-lim)or (y>(123-lim) and y<(512-123+lim )) then
				respawnUpgrader(player)
			end
		end
		end
	 end
   end
end

--return the number of upgrades of the owner of a zone
upgrades = function(zone)
	return owner(zone).upgrades
end

--upgrades a player to a given level
upgrade = function(player,levelindex)
	if (upgradeList[levelindex].level > player.level) and (GetArmyUnitCostTotal(GetArmyBrain(toArmy(player)):GetArmyIndex())) < GetArmyUnitCap(GetArmyBrain(toArmy(player)):GetArmyIndex()) then
		player.level = upgradeList[levelindex].level
		player.upgrades = upgradeList[levelindex].upgrade
		
		--level specific actions
		spawnLevelHero(player,levelindex)
	end
end

--spawn hero unit if necessary given a player and a level
spawnLevelHero = function(player,levelindex)
	local lvl='LEVEL '..upgradeList[levelindex].level
	if lvl == ('LEVEL '.. 4) or lvl==('LEVEL '.. 6) or lvl==('LEVEL '.. 7) or lvl==('LEVEL '.. 9) then
		local spawnzone = findZone(player)
		local x = zoneCenter(spawnzone).x 
		local y = zoneCenter(spawnzone).y
		local hero = CreateUnitHPR(upgradeList[lvl].hero , toArmy(player), x+-4 + math.random(0,1)*8,25,y-4 + math.random(0,1)*8, 0,0,0) 
		hero:SetMaxHealth(upgradeList[lvl].hp)
		hero:SetHealth(hero,upgradeList[lvl].hp )
		hero:SetCustomName(upgradeList[lvl].hero_name .. username(player))
		scnPrint(username(player) .. upgradeList[lvl].hero_desc,player)
	else		
		scnPrint(username(player) .. " has reached " .. upgradeList[levelindex].description,player)
	end
end
		

		
--upgrade attack level trigger
--attack upgrade upgrades unit weapon damage
upgradeAttack = function(player)
	local brain = GetArmyBrain(toArmy(player))
	local energy_price=(player.attack + 1)*500
	if brain:GetEconomyStored('ENERGY') >= energy_price then		
		SetArmyEconomy(toArmy(player),0,-1*energy_price )
		player.attack = player.attack + 1
		updateInfo(player)
		scnPrint(username(player) .. ': upgrading attack to level '..player.attack,player)
	else
		scnPrint(username(player) .. ': not enough Energy for attack upgrade (need '..energy_price..')',player,true)
	end
end

--upgrade defence level trigger
--defence upgrade upgrades unit health as well as tower regen rate
upgradeDefence = function(player)
	local brain = GetArmyBrain(toArmy(player))
	local mass_price=(player.defence + 1)*100
	if brain:GetEconomyStored('MASS') >= mass_price then
		SetArmyEconomy(toArmy(player), mass_price*-1,0 )
		player.defence = player.defence + 1
		
		if not player.ACU:IsDead() then
			player.ACU:SetMaxHealth(8000+player.defence*2000)
			player.ACU:SetHealth(nil,8000+player.defence*2000)
			player.ACU:SetRegenRate(60+player.defence*10)
		end
		updateInfo(player)
		scnPrint(username(player) .. ': upgrading defence to level '..player.defence,player)
		upgradeBunkers(player)
	else		
		scnPrint(username(player) .. ': not enough Mass for defence upgrade (need '.. mass_price.. ')',player,true)
	end
end
	
--replace all bunkers to refresh bunker type
replaceBunkers = function(player)
	local i = 1
	while i <= imax do
		local j = 1
		while j <= jmax do
			if (i > 1 and i < imax) or (j > 1 and j<jmax) then
				local zone = zones[i][j]
				if zone.owner == player.name and zone.bunker != false then
					if not zone.bunker:IsDead() then
						zone.bunker:Kill()	
						spawnBunker(zone)
						addZone(zone.owner)	
					end
				end
			end
			j = j + 1
		end
		i = i + 1
	end	
end


--upgrades all alive bunkers for a player
upgradeBunkers = function(player)
--[[	local i = 1
	while i <= imax do
		local j = 1
		while j <= jmax do
			if (i > 1 and i < imax) or (j > 1 and j<jmax) then
				local zone = zones[i][j]
				if zone.owner == player.name and zone.bunker != false then
					if not zone.bunker:IsDead() then
					bucker_caract(zone.bunker,player)
					end
				end
			end
			j = j + 1
		end
		i = i + 1
	end ]]
	--for i, player in players do
		if player.name!="neutral" and player.name!=nil then
			local brain = GetArmyBrain(toArmy(player))
			local units=brain:GetListOfUnits(categories.TECH1*categories.DEFENSE*categories.STRUCTURE,true) --categories.UEB2301, false)
			for index, unit in units do
				--if unit.checked then
					bucker_caract(unit,player)
					--addBunkerKillCount(unit)
			--		LOG("checked T1")
					--unit.checked=true
				--end
			end
			units=brain:GetListOfUnits(categories.TECH2*categories.DEFENSE*categories.STRUCTURE,true) --categories.UEB2301, false)
			for index, unit in units do
				if unit.checked then
					bucker_caract_lvl2(unit,player)
					--addBunkerKillCount(unit)
			--		LOG("checked T2")
					--unit.checked=true
				end
			end
		end
--	end
	
--	local brain = GetArmyBrain(toArmy(player))
--	brain:GetListOfUnits(categories, boolean)

	
end

--spawns a kamikaze unit if you have enough money
purchaseKamikaze = function(player)
	local brain = GetArmyBrain(toArmy(player))
	local unitcost = 200
	if brain:GetEconomyStored('MASS') >= 500 and brain:GetEconomyStored('ENERGY')>=5000 then
		player.money = player.money - unitcost
		SetArmyEconomy(toArmy(player), -500,-5000)
		--unitcost/5,unitcost/5)
		local spawnzone = findZone(player)
		local x = zoneCenter(spawnzone).x 
		local y = zoneCenter(spawnzone).y
		local kamikaze = CreateUnitHPR( 'URL0303',  toArmy(player), x,25,y + 5, 0,0,0) 
		local health = 3000 + 2000*player.attack
		kamikaze:SetMaxHealth(health)
		kamikaze:SetHealth(nil,health)
		kamikaze:SetAllWeaponsEnabled(false)
		kamikaze:SetSpeedMult(2)
		kamikaze:SetAccMult(3)       
        kamikaze:SetTurnMult(3)
		--addCzarKamikazeAbility(kamikaze)
		addKamikazeAbility(kamikaze)
		kamikaze:SetCustomName('kamikaze: ' .. username(player))
		updateInfo(player)
		scnPrint(username(player) .. ': bought a kamikaze',player)
	else
		scnPrint(username(player) .. ': not enough money to purchase a kamikaze (need 500 Mass and 5000 Energy)',player,true)
	end
end

--Special ability kamikaze
addKamikazeAbility = function(unit)
	unit.OldOnKilled = unit.OnKilled
	unit.OnKilled = function(self, instigator, type, overkillRatio)
		local player = players[armyTable[scnArmy(self)]]
		local position = self:GetPosition()		
		local damage = 10000 + 2000*player.attack
		CreateLightParticle( self, -1, -1, 70, 62, 'flare_lens_add_02', 'ramp_red_10' )
		local deathThread = ForkThread(function()
			WaitSeconds(3)		
			DamageArea(nil, position, 13, damage, 'Normal', true, true)		

		end)		
		unit.OldOnKilled(self, instigator, type, overkillRatio)	
	end	
end

--SPECIAL ABILITY: DEATH CZAR ATTACK uaa0310
addCzarKamikazeAbility = function(unit)
	unit.OldOnKilled = unit.OnKilled
	unit.OnKilled = function(self, instigator, type, overkillRatio)
		local player = players[armyTable[scnArmy(self)]]
		czar = CreateUnitHPR( 'uaa0310', scnArmy(self), self:GetPosition()[1],300,self:GetPosition()[3], 0,0,0)
		czar:GetBlueprint().Wreckage.WreckageLayers.Land=false
		local czardeathThread = ForkThread(function()
			WaitSeconds(5)
			czar:Kill()		
		end)
		unit.OldOnKilled(self, instigator, type, overkillRatio)
	end	
end

--spawns a kamikaze unit if you have enough money
purchaseArtillery = function(player)
	local unitcost = 200
	if player.money >= unitcost then
		player.money = player.money - unitcost
		local startzone = zones[player.startLocation[1]][player.startLocation[2]]
		local x = zoneCenter(startzone).x 
		local y = zoneCenter(startzone).y
		local artillery = CreateUnitHPR( 'UEL0304',  toArmy(player), x,25,y + 5, 0,0,0) 
		artillery:SetMaxHealth(3000)
		artillery:SetHealth(nil,3000)
		artillery:GetWeapon(1):ChangeMaxRadius(30)
		artillery:SetCustomName('artillery: ' .. username(player))
		updateInfo(player)
		scnPrint(username(player) .. ': bought an artillery',player)
	else
		scnPrint(username(player) .. ': not enough money to purchase an artillery',player)
	end
end


--kill and respawn player upgrader  unit
respawnUpgrader = function(player)

	if GetArmyBrain(toArmy(player)).BrainType=="AI" then player.upgrader=false return end
	local xPos = player.upgrader_valx or 20 
	local yPos = player.upgrader_valy or 20

	--destroy upgrader unit if necessary
	if player.upgrader != false and  player.upgrader != nil then
		player.upgrader:SetCanBeKilled(true)
		player.upgrader:Kill()
		player.upgrader = false
		--IssueMove( {player.upgrader}, {xPos,25,yPos} )
	end	
	--spawn upgrader unit
	if player.upgrader == false then 
		player.upgrader = CreateUnitHPR( upgrade_unit, toArmy(player), xPos,25,yPos, 0,0,0) 
		player.upgrader:SetAllWeaponsEnabled(false)	
		player.upgrader:SetCanBeKilled(false)
		player.upgrader:SetDoNotTarget(true)
		player.upgrader:SetMaxHealth(1)
		player.upgrader:SetHealth(nil,1)
		player.upgrader:SetRegenRate(1)
		player.upgrader:SetSpeedMult(7)
		player.upgrader:SetAccMult(5)
		player.upgrader:SetTurnMult(4)
	--	player.upgrader:SetTurnMult(4)
	--	player.upgrader:SetConsumptionPerSecondEnergy(50)
	--	player.upgrader:SetConsumptionPerSecondMass(10)
	--	player.upgrader:SetProductionActive(true)
	--	for i = 1, player.upgrader:GetWeaponCount() do
	--	LOG("------------------------------------------++")
	--	player.upgrader:GetWeapon(i):ChangeMaxRadius(3000)
		--end
		player.upgrader:GetBlueprint().Wreckage.WreckageLayers.Land=false
		--player.upgrader.Decals={}
		--player.upgrader.OnUnitBuilt=function() end
	--	IssueUpgrade({player.upgrader},
		
		--SetProductionActive(false)
--		LOG(repr(player.upgrader))
		player.upgrader:SetCustomName(username(player) .. ': Upgrader')
	end
	
	--LOG(repr(player))
end


--spawn invincible units used to show stats, make upgrades etc
spawnUtilityUnits = function()
	if players['player1'] then
		spawnPlayerUtilityUnits(players['player1'],2,7,1)
	end
	if players['player2'] then
		spawnPlayerUtilityUnits(players['player2'],2,2,2)
	end
	if players['player3'] then
		spawnPlayerUtilityUnits(players['player3'],7,2,3)
	end
	if players['player4'] then
		spawnPlayerUtilityUnits(players['player4'],7,7,4)
	end
	if players['player5'] then
		spawnPlayerUtilityUnits(players['player5'],2,7,5)
	end
	if players['player6'] then
		spawnPlayerUtilityUnits(players['player6'],2,2,6)
	end
	if players['player7'] then
		spawnPlayerUtilityUnits(players['player7'],7,2,7)
	end
	if players['player8'] then
		spawnPlayerUtilityUnits(players['player8'],7,7,8)
	end
	--local nbr=0
	for index,player in players do
	--	nbr=nbr+1
		--upgrade selection unit
		if player.index!=0 then
			local mark = GetMarker("upgrader_"..player.index)
			player.upgrader_valx = mark.position[1]
			player.upgrader_valy = mark.position[3]
			respawnUpgrader(player)
		end
	end
		
end

--spawn invincible units used to show stats, make upgrades etc for a player at a given zone position
spawnPlayerUtilityUnits = function(player,x,y,nbr)

	player.struct={}
	--infoUnit={name="info",unit='uab5202'},
--	local marker={infoUnit={name="info",unit='uab5202'},attackUnit={name="attack",unit='urb5202'},defenceUnit={name="defence",unit='ueb5202'},kamikazeShop={name="kamikaze",unit='URB4201'}}
	local marker={attackUnit={name="attack",unit='uab2305'},defenceUnit={name="defence",unit='uab4302'},kamikazeShop={name="kamikaze",unit='URB4201'}}
	 
	for index,val in marker do
		local mark = GetMarker(val.name.."_"..nbr)
		player[index] = CreateUnitHPR( val.unit, toArmy(player), mark.position[1],25,mark.position[3], 0,0,0) 
		player[index]:SetAllWeaponsEnabled(false)		
		
		player[index]:SetCanBeKilled(false)
		player[index]:SetDoNotTarget(true)
		player[index]:SetMaxHealth(1)
		player[index]:SetHealth(nil,1)
		player[index]:SetRegenRate(1)
		-- Disable nuke?
		for i = 1, player[index]:GetWeaponCount() do
			player[index]:GetWeapon(i):SetEnabled(false) --ChangeMaxRadius(3000)
		end
		player[index]:SetUnSelectable(true)
		if val.name=="defence" then 
			for i=1,7 do 
				player["masslevel_"..i]=CreateUnitHPR( 'uab1106', toArmy(player), mark.position[1],25,mark.position[3], 0,0,0) 
				--if player_equivalent[toArmy(player)] then player["masslevel_"..i]=CreateUnitHPR( 'uab1106', (player_equivalent[toArmy(player)]), mark.position[1],25,mark.position[3], 0,0,0) end
			end
			
		end
		if val.name=="attack" then 
			for i=1,6 do 
				player["energylevel_"..i] = CreateUnitHPR( 'UAB1105', toArmy(player), mark.position[1],25,mark.position[3], 0,0,0)
				--if player_equivalent[toArmy(player)] then player["energylevel_"..i] = CreateUnitHPR( 'UAB1105', (player_equivalent[toArmy(player)]), mark.position[1],25,mark.position[3], 0,0,0) end
			end
			--player.energylevel:GetBlueprint().Economy.StorageEnergy=235
		end
	end
	player.defenceUnit:SetConsumptionPerSecondEnergy(0)
	player.defenceUnit:SetConsumptionPerSecondMass(0)
	player.defenceUnit:SetConsumptionActive(true)
	
	updateInfo(player)
	

end

--update player info
updateInfo = function(player)	
  if GetArmyBrain(toArmy(player)).BrainType!="AI" then
	if player.attackUnit != false then
		player.attackUnit:SetCustomName('Attack level: ' .. player.attack ..', upgrade for: ' .. (player.attack + 1)*500 .. " Energy")
	end
	if player.defenceUnit != false then
		player.defenceUnit:SetCustomName('Defence level: ' .. player.defence ..', upgrade for: ' .. (player.defence + 1)*100 .." Mass")
	end	
	if player.kamikazeShop != false then
		player.kamikazeShop:SetCustomName('Shop, purchase kamikaze for: 500 Mass - 5000 Energy')
	end
  end

end






--~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~MISCALENIOUS FUNCTIONS~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


--SPECIAL ARMY INITIALISATION: NO COMMANDER, NEUTRAL ALWAYS ENEMY
function InitializeArmies()
    local tblGroups = {}
    local tblArmy = ListArmies()
	-- LOG(repr(tblArmy ))
	--determine the players depending on which slots are occupied
	local i=0
	for index,army in tblArmy do
		i=i+1
		players[armyTable[army]] = playersDATA[armyTable[army]]
		players[armyTable[army]].mass=0
		players[armyTable[army]].energy=0
	end
	LOG('playerCount:',playerCount())
	players['neutral'].zonecontrol =60 - playerCount() + 1
	-- spawn less often when numerous player:
	spawnBeatTime=spawnBeatTime+playerCount()
	
	

	
	for iArmy, strArmy in pairs(tblArmy) do
		if strArmy=="ARMY_1" and players["player5"]!=nil then players["player5"].zonecontrol=0 end
		if strArmy=="ARMY_2" and players["player6"]!=nil then players["player6"].zonecontrol=0 end
		if strArmy=="ARMY_3" and players["player7"]!=nil then players["player7"].zonecontrol=0 end
		if strArmy=="ARMY_4" and players["player8"]!=nil then players["player8"].zonecontrol=0 end
		local tblData = Scenario.Armies[strArmy]
		tblGroups[ strArmy ] = {}
		if tblData then
			--make everybody enenies
			for iEnemy, strEnemy in pairs(tblArmy) do
				if iArmy != iEnemy and strArmy != 'NEUTRAL_CIVILIAN' and strEnemy != 'NEUTRAL_CIVILIAN' then
					SetAlliance( iArmy, iEnemy, 'Enemy')
				elseif strArmy == 'NEUTRAL_CIVILIAN' or strEnemy == 'NEUTRAL_CIVILIAN' then
					SetAlliance( iArmy, iEnemy, 'Neutral')
				end
			end
		end
	end
	
	for iArmy, strArmy in pairs(tblArmy) do

		local tblData = Scenario.Armies[strArmy]
		tblGroups[ strArmy ] = {}
		players[armyTable[strArmy]].index_Army=iArmy
		players[armyTable[strArmy]].index=iArmy
		if tblData then

			SetArmyUnitCap(strArmy,maxUnit)
			AddBuildRestriction(iArmy,cat_pd)
			for iEnemy, strEnemy in pairs(tblArmy) do
		
				if (strArmy=="ARMY_1" and strEnemy=="ARMY_5") or (strArmy=="ARMY_5" and strEnemy=="ARMY_1") 
				   or (strArmy=="ARMY_2" and strEnemy=="ARMY_6") or (strArmy=="ARMY_6" and strEnemy=="ARMY_2") 
				   or (strArmy=="ARMY_3" and strEnemy=="ARMY_7") or (strArmy=="ARMY_7" and strEnemy=="ARMY_3")
				   or (strArmy=="ARMY_4" and strEnemy=="ARMY_8") or (strArmy=="ARMY_8" and strEnemy=="ARMY_4") then
					SetAlliance( iArmy, iEnemy, 'Ally')
					for iTeam, strTeam in pairs(tblArmy) do
						if iArmy!=iTeam and IsAlly(iArmy,iTeam) then
							SetAlliance( iEnemy,iTeam, 'Ally')
						end
						if iArmy!=iTeam and IsAlly(iEnemy,iTeam) then
							SetAlliance( iArmy,iTeam, 'Ally')
						end
					end			
				player_equivalent[strArmy]=strEnemy
				player_equivalent_i[iArmy]=iEnemy
				end
			end


		end

	end
	for index,player in players do
	  if GetArmyBrain(toArmy(player)).BrainType=="AI" and player.ai!=nil then
		if ScenarioInfo.ArmySetup[GetArmyBrain(toArmy(player)).Name].AIPersonality =="easy" then
			LOG(username(player)..'('..player.name.."): NORMAL (easy) AI for ZONE CONTROL EXTENDED")
			player.ai.rangePD=70
			player.ai.agressivity_against_human=2
			player.ai.intel_look=3
			player.ai.skip_objectif=4
			player.ai.vivacity=3
		elseif ScenarioInfo.ArmySetup[GetArmyBrain(toArmy(player)).Name].AIPersonality =='medium' or ScenarioInfo.ArmySetup[GetArmyBrain(toArmy(player)).Name].AIPersonality =='random' or ScenarioInfo.ArmySetup[GetArmyBrain(toArmy(player)).Name].AIPersonality =='balanced' then
			LOG(username(player)..'('..player.name.."): MEDIUM AI for ZONE CONTROL EXTENDED")
			player.ai.rangePD=90
			player.ai.agressivity_against_human=3
			player.ai.intel_look=3
			player.ai.skip_objectif=6
			player.ai.vivacity=1
		elseif ScenarioInfo.ArmySetup[GetArmyBrain(toArmy(player)).Name].AIPersonality =='hard' then
			LOG(username(player)..'('..player.name.."): HARD AI for ZONE CONTROL EXTENDED")
			player.ai.rangePD=128
			player.ai.agressivity_against_human=5
			player.ai.intel_look=3
			player.ai.skip_objectif=5
			player.ai.vivacity=1
		else
			LOG(username(player)..'('..player.name.."): MEDIUM AI for ZONE CONTROL EXTENDED (nothing specify)")
			player.ai.rangePD=90
			player.ai.agressivity_against_human=3
			player.ai.intel_look=3
			player.ai.skip_objectif=5
			player.ai.vivacity=1
		end
	   end
	end

    return tblGroups
end
function fix_team()
	--display_team()
	for i, player1 in players do
		if player1.index_Army<5 and player1.index_Army!=0 and player_equivalent_i[player1.index_Army]!=nil then
			SetAlliance( player1.index_Army, player_equivalent_i[player1.index_Army], 'Ally')
			for j, player2 in players do
				if i!=j and IsAlly(toArmy(player1),toArmy(player2)) then
					if player_equivalent_i[player1.index_Army] then SetAlliance( player_equivalent_i[player1.index_Army], player2.index_Army, 'Ally') end
				else
					if i!=j and player2.index_Army!=0 and player_equivalent_i[player1.index_Army] then SetAlliance( player_equivalent_i[player1.index_Army], player2.index_Army, 'Enemy') end
				end
			end
		end
	end
	display_team()
end

function GetMarker(name)
    return Scenario.MasterChain._MASTERCHAIN_.Markers[name]
end

